View Issue Details

IDProjectCategoryView StatusLast Update
0001998XdebugStep Debuggingpublic2021-09-05 16:15
Reporteragustingomes Assigned Toderick  
PrioritylowSeveritymajorReproducibilityalways
Status closedResolutionfixed 
Product Version3.1dev 
Target Version3.1devFixed in Version3.1.0beta1 
Summary0001998: Double facet attribute generated for enums that are stored in properties
DescriptionThe step debugging process seem to end up abruptly when the assignment of an enum is done inside a class. PHPStorm seems to receive an instruction to break the execution of the script, but continues immediately afterwards.

This happens on the current master state of the branch: (https://github.com/xdebug/xdebug/commit/b1a26aef7b94374d44e0cfda6b283d8955a916a5)
Steps To Reproduceconsider the following script:
```
<?php
enum Currency: string {
    case EUR = "€";
    case GBP = "£";
}

final class TotalAmount
{
    private int $amount;

    private Currency $currency;

    public function __construct(int $amount, Currency $currency)
    {
        $this->amount = $amount;
        $this->currency = $currency;
    }
}

$totalAmount = new TotalAmount(30, Currency::EUR);

echo "Hi!\n";
```

Adding a breakpoint in the `echo "Hi!\n";` doesn't work, and the program continues it's execution, finishing with exit code 0
Additional InformationFrom the initial information I managed to collect, it seems the issue is in how the `currency` property is described. the property node has 2 facets, one with the property visibility, and another specifying it's an enum:

<property name="currency" fullname="$totalAmount->currency" facet="private" type="object" facet="enum" classname="Currency" children="1" numchildren="2"></property>
TagsDoesn't Break
Operating SystemLinux
PHP Version8.1-dev

Activities

agustingomes

2021-07-24 17:09

reporter  

logs.log (19,148 bytes)   
[7] Log opened at 2021-07-24 16:58:08.751631
[7] [Config] INFO: Trigger value for 'XDEBUG_TRIGGER' not found, falling back to 'XDEBUG_SESSION'
[7] [Config] INFO: No shared secret: Activating
[7] [Step Debug] INFO: Connecting to configured address/port: 172.17.0.1:9003.
[7] [Step Debug] INFO: Connected to debugging client: 172.17.0.1:9003 (through xdebug.client_host/xdebug.client_port). :-)
[7] [Step Debug] -> <init xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" fileuri="file:///opt/project/agustin/bin/customConsole" language="PHP" xdebug:language_version="8.1.0beta1" protocol_version="1.0" appid="7" idekey="rover"><engine version="3.1.0-dev"><![CDATA[Xdebug]]></engine><author><![CDATA[Derick Rethans]]></author><url><![CDATA[https://xdebug.org]]></url><copyright><![CDATA[Copyright (c) 2002-2021 by Derick Rethans]]></copyright></init>

[7] [Step Debug] <- eval -i 1 -- KHN0cmluZykoaW5pX2dldCgneGRlYnVnLmNvdmVyYWdlX2VuYWJsZScpLic7Jy5pbmlfZ2V0KCd4ZGVidWcucHJvZmlsZXJfZW5hYmxlJykuJzsnLmluaV9nZXQoJ3hkZWJ1Zy5yZW1vdGVfYXV0b3N0YXJ0JykuJzsnLmluaV9nZXQoJ3hkZWJ1Zy5yZW1vdGVfY29ubmVjdF9iYWNrJykuJzsnLmluaV9nZXQoJ3hkZWJ1Zy5yZW1vdGVfbW9kZScpKQ==
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="eval" transaction_id="1"><property type="string" size="635" encoding="base64"><![CDATA[VGhpcyBzZXR0aW5nIGhhcyBiZWVuIGNoYW5nZWQsIHNlZSB0aGUgdXBncmFkaW5nIGd1aWRlIGF0IGh0dHBzOi8veGRlYnVnLm9yZy9kb2NzL3VwZ3JhZGVfZ3VpZGUjY2hhbmdlZC14ZGVidWcuY292ZXJhZ2VfZW5hYmxlO1RoaXMgc2V0dGluZyBoYXMgYmVlbiBjaGFuZ2VkLCBzZWUgdGhlIHVwZ3JhZGluZyBndWlkZSBhdCBodHRwczovL3hkZWJ1Zy5vcmcvZG9jcy91cGdyYWRlX2d1aWRlI2NoYW5nZWQteGRlYnVnLnByb2ZpbGVyX2VuYWJsZTtUaGlzIHNldHRpbmcgaGFzIGJlZW4gY2hhbmdlZCwgc2VlIHRoZSB1cGdyYWRpbmcgZ3VpZGUgYXQgaHR0cHM6Ly94ZGVidWcub3JnL2RvY3MvdXBncmFkZV9ndWlkZSNjaGFuZ2VkLXhkZWJ1Zy5yZW1vdGVfYXV0b3N0YXJ0O1RoaXMgc2V0dGluZyBoYXMgYmVlbiBjaGFuZ2VkLCBzZWUgdGhlIHVwZ3JhZGluZyBndWlkZSBhdCBodHRwczovL3hkZWJ1Zy5vcmcvZG9jcy91cGdyYWRlX2d1aWRlI2NoYW5nZWQteGRlYnVnLnJlbW90ZV9jb25uZWN0X2JhY2s7VGhpcyBzZXR0aW5nIGhhcyBiZWVuIGNoYW5nZWQsIHNlZSB0aGUgdXBncmFkaW5nIGd1aWRlIGF0IGh0dHBzOi8veGRlYnVnLm9yZy9kb2NzL3VwZ3JhZGVfZ3VpZGUjY2hhbmdlZC14ZGVidWcucmVtb3RlX21vZGU=]]></property></response>

[7] [Step Debug] <- feature_set -i 2 -n show_hidden -v 1
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="2" feature="show_hidden" success="1"></response>

[7] [Step Debug] <- feature_set -i 3 -n max_depth -v 1
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="3" feature="max_depth" success="1"></response>

[7] [Step Debug] <- feature_set -i 4 -n max_children -v 100
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="4" feature="max_children" success="1"></response>

[7] [Step Debug] <- feature_set -i 5 -n extended_properties -v 1
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="5" feature="extended_properties" success="1"></response>

[7] [Step Debug] <- feature_set -i 6 -n notify_ok -v 1
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="6" feature="notify_ok" success="1"></response>

[7] [Step Debug] <- feature_set -i 7 -n resolved_breakpoints -v 1
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="7" feature="resolved_breakpoints" success="1"></response>

[7] [Step Debug] <- stdout -i 8 -c 1
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="stdout" transaction_id="8" success="1"></response>

[7] [Step Debug] <- status -i 9
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="status" transaction_id="9" status="starting" reason="ok"></response>

[7] [Step Debug] <- step_into -i 10
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="step_into" transaction_id="10" status="break" reason="ok"><xdebug:message filename="file:///opt/project/agustin/bin/customConsole" lineno="3"></xdebug:message></response>

[7] [Step Debug] <- eval -i 11 -- aXNzZXQoJF9TRVJWRVJbJ1BIUF9JREVfQ09ORklHJ10p
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="eval" transaction_id="11"><property type="bool"><![CDATA[1]]></property></response>

[7] [Step Debug] <- eval -i 12 -- KHN0cmluZykoJF9TRVJWRVJbJ1BIUF9JREVfQ09ORklHJ10p
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="eval" transaction_id="12"><property type="string" size="16" encoding="base64"><![CDATA[c2VydmVyTmFtZT1yb3Zlcg==]]></property></response>

[7] [Step Debug] <- breakpoint_set -i 13 -t line -f file:///opt/project/agustin/bin/customConsole -n 23
[7] [Step Debug] -> <notify xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" name="breakpoint_resolved"><breakpoint type="line" resolved="resolved" filename="file:///opt/project/agustin/bin/customConsole" lineno="23" state="enabled" hit_count="0" hit_value="0" id="70001"></breakpoint></notify>

[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="breakpoint_set" transaction_id="13" id="70001" resolved="resolved"></response>

[7] [Step Debug] <- breakpoint_set -i 14 -t line -f file:///opt/project/agustin/bin/customConsole -n 24
[7] [Step Debug] -> <notify xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" name="breakpoint_resolved"><breakpoint type="line" resolved="resolved" filename="file:///opt/project/agustin/bin/customConsole" lineno="24" state="enabled" hit_count="0" hit_value="0" id="70002"></breakpoint></notify>

[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="breakpoint_set" transaction_id="14" id="70002" resolved="resolved"></response>

[7] [Step Debug] <- stack_get -i 15
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="stack_get" transaction_id="15"><stack where="{main}" level="0" type="file" filename="file:///opt/project/agustin/bin/customConsole" lineno="3"></stack></response>

[7] [Step Debug] <- run -i 16
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="run" transaction_id="16" status="break" reason="ok"><xdebug:message filename="file:///opt/project/agustin/bin/customConsole" lineno="23"></xdebug:message></response>

[7] [Step Debug] <- stack_get -i 17
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="stack_get" transaction_id="17"><stack where="{main}" level="0" type="file" filename="file:///opt/project/agustin/bin/customConsole" lineno="23"></stack></response>

[7] [Step Debug] <- context_names -i 18
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="context_names" transaction_id="18"><context name="Locals" id="0"></context><context name="Superglobals" id="1"></context><context name="User defined constants" id="2"></context></response>

[7] [Step Debug] <- context_get -i 19 -d 0 -c 0
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="context_get" transaction_id="19" context="0"><property name="$totalAmount" fullname="$totalAmount" type="object" classname="TotalAmount" children="1" numchildren="2" page="0" pagesize="100"><property name="amount" fullname="$totalAmount-&gt;amount" facet="private" type="int"><![CDATA[30]]></property><property name="currency" fullname="$totalAmount-&gt;currency" facet="private" type="object" facet="enum" classname="Currency" children="1" numchildren="2"></property></property></response>

[7] [Step Debug] -> <stream xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" type="stdout" encoding="base64"><![CDATA[SGkhCg==]]></stream>

[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="context_get" transaction_id="19" status="break" reason="ok"><xdebug:message filename="file:///opt/project/agustin/bin/customConsole" lineno="24"></xdebug:message></response>

[7] [Step Debug] WARN: 2021-07-24 16:58:08.949568: There was a problem sending 320 bytes on socket 6: Broken pipe.
[7] [Step Debug] -> <stream xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" type="stdout" encoding="base64"><![CDATA[QnllIQo=]]></stream>

[7] [Step Debug] WARN: 2021-07-24 16:58:08.949592: There was a problem sending 197 bytes on socket 6: Broken pipe.
[7] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" status="stopping" reason="ok"></response>

[7] [Step Debug] WARN: 2021-07-24 16:58:08.949648: There was a problem sending 179 bytes on socket 6: Broken pipe.
[7] Log closed at 2021-07-24 16:58:08.949806

[8] Log opened at 2021-07-24 17:04:02.626433
[8] [Config] INFO: Trigger value for 'XDEBUG_TRIGGER' not found, falling back to 'XDEBUG_SESSION'
[8] [Config] INFO: No shared secret: Activating
[8] [Step Debug] INFO: Connecting to configured address/port: 172.17.0.1:9003.
[8] [Step Debug] INFO: Connected to debugging client: 172.17.0.1:9003 (through xdebug.client_host/xdebug.client_port). :-)
[8] [Step Debug] -> <init xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" fileuri="file:///opt/project/agustin/bin/customConsole" language="PHP" xdebug:language_version="8.1.0beta1" protocol_version="1.0" appid="8" idekey="rover"><engine version="3.1.0-dev"><![CDATA[Xdebug]]></engine><author><![CDATA[Derick Rethans]]></author><url><![CDATA[https://xdebug.org]]></url><copyright><![CDATA[Copyright (c) 2002-2021 by Derick Rethans]]></copyright></init>

[8] [Step Debug] <- eval -i 1 -- KHN0cmluZykoaW5pX2dldCgneGRlYnVnLmNvdmVyYWdlX2VuYWJsZScpLic7Jy5pbmlfZ2V0KCd4ZGVidWcucHJvZmlsZXJfZW5hYmxlJykuJzsnLmluaV9nZXQoJ3hkZWJ1Zy5yZW1vdGVfYXV0b3N0YXJ0JykuJzsnLmluaV9nZXQoJ3hkZWJ1Zy5yZW1vdGVfY29ubmVjdF9iYWNrJykuJzsnLmluaV9nZXQoJ3hkZWJ1Zy5yZW1vdGVfbW9kZScpKQ==
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="eval" transaction_id="1"><property type="string" size="635" encoding="base64"><![CDATA[VGhpcyBzZXR0aW5nIGhhcyBiZWVuIGNoYW5nZWQsIHNlZSB0aGUgdXBncmFkaW5nIGd1aWRlIGF0IGh0dHBzOi8veGRlYnVnLm9yZy9kb2NzL3VwZ3JhZGVfZ3VpZGUjY2hhbmdlZC14ZGVidWcuY292ZXJhZ2VfZW5hYmxlO1RoaXMgc2V0dGluZyBoYXMgYmVlbiBjaGFuZ2VkLCBzZWUgdGhlIHVwZ3JhZGluZyBndWlkZSBhdCBodHRwczovL3hkZWJ1Zy5vcmcvZG9jcy91cGdyYWRlX2d1aWRlI2NoYW5nZWQteGRlYnVnLnByb2ZpbGVyX2VuYWJsZTtUaGlzIHNldHRpbmcgaGFzIGJlZW4gY2hhbmdlZCwgc2VlIHRoZSB1cGdyYWRpbmcgZ3VpZGUgYXQgaHR0cHM6Ly94ZGVidWcub3JnL2RvY3MvdXBncmFkZV9ndWlkZSNjaGFuZ2VkLXhkZWJ1Zy5yZW1vdGVfYXV0b3N0YXJ0O1RoaXMgc2V0dGluZyBoYXMgYmVlbiBjaGFuZ2VkLCBzZWUgdGhlIHVwZ3JhZGluZyBndWlkZSBhdCBodHRwczovL3hkZWJ1Zy5vcmcvZG9jcy91cGdyYWRlX2d1aWRlI2NoYW5nZWQteGRlYnVnLnJlbW90ZV9jb25uZWN0X2JhY2s7VGhpcyBzZXR0aW5nIGhhcyBiZWVuIGNoYW5nZWQsIHNlZSB0aGUgdXBncmFkaW5nIGd1aWRlIGF0IGh0dHBzOi8veGRlYnVnLm9yZy9kb2NzL3VwZ3JhZGVfZ3VpZGUjY2hhbmdlZC14ZGVidWcucmVtb3RlX21vZGU=]]></property></response>

[8] [Step Debug] <- feature_set -i 2 -n show_hidden -v 1
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="2" feature="show_hidden" success="1"></response>

[8] [Step Debug] <- feature_set -i 3 -n max_depth -v 1
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="3" feature="max_depth" success="1"></response>

[8] [Step Debug] <- feature_set -i 4 -n max_children -v 100
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="4" feature="max_children" success="1"></response>

[8] [Step Debug] <- feature_set -i 5 -n extended_properties -v 1
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="5" feature="extended_properties" success="1"></response>

[8] [Step Debug] <- feature_set -i 6 -n notify_ok -v 1
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="6" feature="notify_ok" success="1"></response>

[8] [Step Debug] <- feature_set -i 7 -n resolved_breakpoints -v 1
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="feature_set" transaction_id="7" feature="resolved_breakpoints" success="1"></response>

[8] [Step Debug] <- stdout -i 8 -c 1
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="stdout" transaction_id="8" success="1"></response>

[8] [Step Debug] <- status -i 9
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="status" transaction_id="9" status="starting" reason="ok"></response>

[8] [Step Debug] <- step_into -i 10
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="step_into" transaction_id="10" status="break" reason="ok"><xdebug:message filename="file:///opt/project/agustin/bin/customConsole" lineno="3"></xdebug:message></response>

[8] [Step Debug] <- eval -i 11 -- aXNzZXQoJF9TRVJWRVJbJ1BIUF9JREVfQ09ORklHJ10p
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="eval" transaction_id="11"><property type="bool"><![CDATA[1]]></property></response>

[8] [Step Debug] <- eval -i 12 -- KHN0cmluZykoJF9TRVJWRVJbJ1BIUF9JREVfQ09ORklHJ10p
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="eval" transaction_id="12"><property type="string" size="16" encoding="base64"><![CDATA[c2VydmVyTmFtZT1yb3Zlcg==]]></property></response>

[8] [Step Debug] <- breakpoint_set -i 13 -t line -f file:///opt/project/agustin/bin/customConsole -n 23
[8] [Step Debug] -> <notify xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" name="breakpoint_resolved"><breakpoint type="line" resolved="resolved" filename="file:///opt/project/agustin/bin/customConsole" lineno="23" state="enabled" hit_count="0" hit_value="0" id="80001"></breakpoint></notify>

[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="breakpoint_set" transaction_id="13" id="80001" resolved="resolved"></response>

[8] [Step Debug] <- breakpoint_set -i 14 -t line -f file:///opt/project/agustin/bin/customConsole -n 24
[8] [Step Debug] -> <notify xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" name="breakpoint_resolved"><breakpoint type="line" resolved="resolved" filename="file:///opt/project/agustin/bin/customConsole" lineno="24" state="enabled" hit_count="0" hit_value="0" id="80002"></breakpoint></notify>

[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="breakpoint_set" transaction_id="14" id="80002" resolved="resolved"></response>

[8] [Step Debug] <- stack_get -i 15
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="stack_get" transaction_id="15"><stack where="{main}" level="0" type="file" filename="file:///opt/project/agustin/bin/customConsole" lineno="3"></stack></response>

[8] [Step Debug] <- run -i 16
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="run" transaction_id="16" status="break" reason="ok"><xdebug:message filename="file:///opt/project/agustin/bin/customConsole" lineno="23"></xdebug:message></response>

[8] [Step Debug] <- stack_get -i 17
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="stack_get" transaction_id="17"><stack where="{main}" level="0" type="file" filename="file:///opt/project/agustin/bin/customConsole" lineno="23"></stack></response>

[8] [Step Debug] <- context_names -i 18
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="context_names" transaction_id="18"><context name="Locals" id="0"></context><context name="Superglobals" id="1"></context><context name="User defined constants" id="2"></context></response>

[8] [Step Debug] <- context_get -i 19 -d 0 -c 0
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="context_get" transaction_id="19" context="0"><property name="$totalAmount" fullname="$totalAmount" type="object" classname="TotalAmount" children="1" numchildren="2" page="0" pagesize="100"><property name="amount" fullname="$totalAmount-&gt;amount" facet="private" type="int"><![CDATA[30]]></property><property name="currency" fullname="$totalAmount-&gt;currency" facet="private" type="object" facet="enum" classname="Currency" children="1" numchildren="2"></property></property></response>

[8] [Step Debug] -> <stream xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" type="stdout" encoding="base64"><![CDATA[SGkhCg==]]></stream>

[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" command="context_get" transaction_id="19" status="break" reason="ok"><xdebug:message filename="file:///opt/project/agustin/bin/customConsole" lineno="24"></xdebug:message></response>

[8] [Step Debug] WARN: 2021-07-24 17:04:02.862251: There was a problem sending 320 bytes on socket 6: Broken pipe.
[8] [Step Debug] -> <stream xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" type="stdout" encoding="base64"><![CDATA[QnllIQo=]]></stream>

[8] [Step Debug] WARN: 2021-07-24 17:04:02.862275: There was a problem sending 197 bytes on socket 6: Broken pipe.
[8] [Step Debug] -> <response xmlns="urn:debugger_protocol_v1" xmlns:xdebug="https://xdebug.org/dbgp/xdebug" status="stopping" reason="ok"></response>

[8] [Step Debug] WARN: 2021-07-24 17:04:02.862340: There was a problem sending 179 bytes on socket 6: Broken pipe.
[8] Log closed at 2021-07-24 17:04:02.862520

logs.log (19,148 bytes)   

derick

2021-07-27 23:36

administrator   ~0005944

Thanks for this. I think that some XML parsers might stumble over this. Xdebug's DBGp Client or test framework does not, but I guess PhpStorm does. I'll go try it with PhpStorm (which seems to close the debugging connection), and then proceed with a fix.

derick

2021-07-28 09:49

administrator   ~0005945

https://github.com/xdebug/xdebug/pull/764

derick

2021-07-28 11:04

administrator   ~0005946

I've merged this in GIT now, and from my cursory testing with PhpStorm it now works. It'd be great if you could test it again too please.

agustingomes

2021-07-28 11:37

reporter   ~0005948

Hi Derick.

I recompiled the Docker image with the latest master branch, and I can confirm the fix works. Thank you for looking into this so quickly.

Issue History

Date Modified Username Field Change
2021-07-24 17:09 agustingomes New Issue
2021-07-24 17:09 agustingomes Tag Attached: Doesn't Break
2021-07-24 17:09 agustingomes File Added: logs.log
2021-07-27 23:36 derick Assigned To => derick
2021-07-27 23:36 derick Status new => confirmed
2021-07-27 23:36 derick Note Added: 0005944
2021-07-27 23:36 derick Severity minor => major
2021-07-27 23:36 derick Product Version => 3.1dev
2021-07-27 23:36 derick Target Version => 3.1dev
2021-07-27 23:36 derick Description Updated
2021-07-27 23:36 derick Steps to Reproduce Updated
2021-07-27 23:36 derick Additional Information Updated
2021-07-28 09:47 derick Summary Step debugger stops when assigning enum to a property => Double facet attribute generated for enums that are stored in properties
2021-07-28 09:49 derick Note Added: 0005945
2021-07-28 11:04 derick Status confirmed => closed
2021-07-28 11:04 derick Resolution open => fixed
2021-07-28 11:04 derick Fixed in Version => 3.1dev
2021-07-28 11:04 derick Note Added: 0005946
2021-07-28 11:37 agustingomes Note Added: 0005948
2021-09-05 16:15 derick Fixed in Version 3.1dev => 3.1.0beta1